import java.io.Serializable;
import java.util.*;

import org.hibernate.*;
import org.hibernate.cfg.*;
import org.hibernate.criterion.*;
import org.hibernate.event.*;
import org.hibernate.event.def.*;

public class Main {
   public static void main(String[] args) throws Exception {
      HibernateUtil.setup("create table employee (id int,name varchar);");    
      HibernateUtil.setup("create table benefit (id int,cost int);");    
      HibernateUtil.setup("create table employee_benefit (parent_id int,benefit_name varchar,benefit_id int);");    


      Session session = HibernateUtil.currentSession();
      Employee sp = new Employee();
      Employee sp3 = new Employee();
     
      sp.setName("Joe");
      HashMap p = new HashMap();
      p.put("health", new Benefit(200));
      p.put("dental", new Benefit(300));
      sp.setBenefits(p);

      sp3.setName("Jim");
      sp3.setBenefits(p);

      session.save(sp);
      session.save(sp3);
      session.flush();

      HibernateUtil.closeSession();
      session = HibernateUtil.currentSession();

      Employee sp2 = (Employee)session.load(Employee.class, new Integer(sp.getId()));

      Map p2 = sp2.getBenefits();
      System.out.println(((Benefit)p2.get("health")).getCost());
      System.out.println(((Benefit)p2.get("dental")).getCost());


      session.flush();
      session.close();
      HibernateUtil.checkData("select * from employee");
      HibernateUtil.checkData("select * from benefit");
      HibernateUtil.checkData("select * from employee_benefit");
   }
}
